#!/bin/bash
#
# push ubuntu phone tarball to sdcard
# Andrew Sutherland <dr3wsuth3rland@gmail.com>

# XXX: Comment this out
echo "This script involves sudo, you are required to read it before running"; exit

if [ $# -ne 2 ]; then
    echo "Usage $0 <zip> </path/to/disk>"
    exit
fi

zip=$1
part=$2
if [ ! -d "$part" ]; then
    echo "$part does not exist.. is your path right?"
    exit 1
fi
if [ ! -f "$zip" ]; then
    echo "$zip not found.. is your path right?"
    exit 1
fi

tmp=$(mktemp -d)
echo "Unzipping"
sudo unzip $zip -d $tmp >/dev/null
pushd $tmp >/dev/null
echo "Unpacking Tarball"
## --numeric-owner very important to get the right perms
sudo tar --numeric-owner -zxf $(find . -type f -name *.tar.gz)
echo "Copying rootfs.. This can take a few minutes"
## sudo rm -r $part/ubuntu/
## using --delete for quicker upgrades
sudo rsync -a --delete binary/casper/filesystem.dir/ $part/ubuntu/
popd >/dev/null
echo "Installing ubuntu-session configs"
for ii in $(ls ./ubuntu-session.d); do
    sudo cp ./ubuntu-session.d/$ii $part/ubuntu/etc/ubuntu-session.d/$ii
    sudo chown root.root $part/ubuntu/etc/ubuntu-session.d/$ii
    sudo chmod 644 $part/ubuntu/etc/ubuntu-session.d/$ii
done
echo "Syncing disks.. This can take a few minutes"
sync
echo "Cleaning up"
sudo rm -r $tmp
echo "Done."
echo "Now unmount the sdcard and put back in phone."
